#!/usr/bin/env python
# @deKay01 2016/01/20

# Pull in all the required library stuff
import time
import sys
import RPi.GPIO as gpio
from tweepy import OAuthHandler
from tweepy import Stream
from tweepy.streaming import StreamListener

# These are needed from dev.twitter.com
access_token = "***"
access_token_secret = "***"
consumer_key = "***"
consumer_secret = "***"

# Pulls your search term in from the command's argument
searchterm = sys.argv[1]

# Opens a file to put results into
f = open(searchterm+".txt",'w')

# Assumes LED is connected to pin 22 on the Pi
led = 22

# Initialises LED
gpio.setmode(gpio.BOARD)
gpio.setup(led, gpio.OUT)
gpio.output(led, gpio.LOW)

# A class to listen to the Twitter stream
class myListener(StreamListener):
  def on_status(self, status):

    # When there's a match...
    try:
       # Output to stdout
       print ("@{}: {}, ID={}\n".format(  str(status.user.screen_name.encode('utf-8')) , str(status.text.encode('utf-8')) , status.user.id_str  ))
       # Also output to file
       f.write("@{}: {}, ID={}\n".format(  str(status.user.screen_name.encode('utf-8')) , str(status.text.encode('utf-8')) , status.user.id_str  ))
       f.write("\n\n")
       # Flash that LED
       gpio.output(led, gpio.HIGH)
       time.sleep(0.2)
       gpio.output(led, gpio.LOW)
       
    except Exception as e:
      print(e)
                                            
  def on_error(self, status_code):
    print(status_code)
                                                        
while True:
  try:
    # Pull in the stream and loop forever
    auth = OAuthHandler(consumer_key, consumer_secret)
    auth.set_access_token(access_token, access_token_secret)
    twitterStream = Stream(auth, myListener())
    twitterStream.filter(track=[searchterm],languages=['en'])

  except Exception as e:
    print(e)
